#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include "src/ofbis.h"

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))

FB	*f;

static void signal_handler(int sig)
{
  fprintf(stderr,"fbtst: signal %d caught and exits program!\n", sig);
  FBclose(f);;
  exit(1);
}
      
static void setup_signals()
{
  sigset_t mask;
  struct sigaction sigs;
          
  sigemptyset(&mask);
            
  sigs.sa_handler = signal_handler;
  sigs.sa_mask = mask;
  sigs.sa_flags = SA_ONESHOT;
  sigs.sa_restorer = NULL;
             
  sigaction(SIGHUP, &sigs, NULL);
  sigaction(SIGINT, &sigs, NULL);
  sigaction(SIGQUIT, &sigs, NULL);
  sigaction(SIGILL, &sigs, NULL);
  sigaction(SIGTRAP, &sigs, NULL);
  sigaction(SIGBUS, &sigs, NULL);
  sigaction(SIGFPE, &sigs, NULL);
  sigaction(SIGSEGV, &sigs, NULL);
  sigaction(SIGTERM, &sigs, NULL);
}
                                      

int
main( int argc, char **argv )
{
#define FB_OPT FB_OPEN_NEW_VC

  if ((f=FBopen(NULL,FB_OPT /*FB_KEEP_CURRENT_VC*/))==NULL)
  {
    printf("FBinit f failed");

    return -1;
  }

  fprintf (stderr, "xres_virtual=%d\n", f->vinf.xres_virtual);

  setup_signals();
  

  {
    int  i = 0;
    char ch;
    fprintf(stderr, "fbtst: before FBgetchar\n");

    while((i < 10))
    {
      FBEVENT event;

      FBgetevent(f, &event);

      switch(event.type)
      {
      case FBNoEvent:
        fprintf(stderr, "FBNoEvent\n");
        break;

      case FBKeyEvent:
        fprintf(stderr, "FBKeyEvent\n");
        break;

      case FBMouseEvent:
        fprintf(stderr,
                "FBMouseEvent: %d %d %d %d\n",
                event.mouse.x,
                event.mouse.y,
                event.mouse.state,
                event.mouse.buttons);
        break;

      default:
        fprintf(stderr, "Unknown event!\n");
      }

      i++;
    }

    fprintf(stderr, "fbtst: after FBgetchar\n");
  }

  FBclose(f);
  
  return 0;
}
